//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3DA1B0B202CC.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3DA1B0B202CC.cm

//## begin module%3DA1B0B202CC.cp preserve=no
//## end module%3DA1B0B202CC.cp

//## Module: PlotData%3DA1B0B202CC; Package body
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotData.cxx

//## begin module%3DA1B0B202CC.additionalIncludes preserve=no
//## end module%3DA1B0B202CC.additionalIncludes

//## begin module%3DA1B0B202CC.includes preserve=yes
#include <XSPlot/Plot/CreateBinnedPlotGroups.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotTypes.h>
//## end module%3DA1B0B202CC.includes

// PlotData
#include <XSPlot/Commands/PlotData.h>
//## begin module%3DA1B0B202CC.declarations preserve=no
//## end module%3DA1B0B202CC.declarations

//## begin module%3DA1B0B202CC.additionalDeclarations preserve=yes
//## end module%3DA1B0B202CC.additionalDeclarations


// Class PlotData 

PlotData::PlotData (const string& name, bool isCounts)
  //## begin PlotData::PlotData%3DA1B95D0212.hasinit preserve=no
  //## end PlotData::PlotData%3DA1B95D0212.hasinit
  //## begin PlotData::PlotData%3DA1B95D0212.initialization preserve=yes
  : PlotCommand(name, new CreateBinnedPlotGroups(false,isCounts)),
   m_isCounts(isCounts)
  //## end PlotData::PlotData%3DA1B95D0212.initialization
{
  //## begin PlotData::PlotData%3DA1B95D0212.body preserve=yes
  isDataRequired(true);
  isActiveModelRequired(false);
  isDivisibleByArea(true);
  addCompLevel(2);
  isBackgroundApplicable(true);
  isLineIDApplicable(true);
  isPlotGroupDonor(true);
  
  PlotAttributes styles;
  styles.symbolStyle = PlotCommand::standardDataStyle();
  styles.lineStyle = PlotStyle::NONE;
  setStyleMap(PlotStyle::DATA, styles);
  styles.symbolStyle = PlotStyle::ASTERISK;
  styles.lineStyle = PlotStyle::NONE; 
  setStyleMap(PlotStyle::BACKGROUND, styles); 
  styles.symbolStyle = PlotStyle::BLANK;
  styles.lineStyle = PlotCommand::standardModelStyle();
  styles.lineStep = true;
  styles.lineWidth = 2;
  setStyleMap(PlotStyle::MODEL, styles);
  styles.lineStep = false;
  styles.lineStyle = PlotStyle::DOTTED;
  setStyleMap(PlotStyle::SOURCES, styles);
  
  //## end PlotData::PlotData%3DA1B95D0212.body
}


PlotData::~PlotData()
{
  //## begin PlotData::~PlotData%3DA1B20603E3_dest.body preserve=yes
  //## end PlotData::~PlotData%3DA1B20603E3_dest.body
}



//## Other Operations (implementation)
void PlotData::setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotData::setRanges%4ACCF6E90219.body preserve=yes
   Real xlow=0.0, xhigh=0.0;
   PlotGroupCreator::determineXRange(plotGroups,&xlow,&xhigh);
  
   PlotRange& rangeVals = rangeSettings();
   rangeVals.ranges.x1 = xlow;
   rangeVals.ranges.x2 = xhigh;
   
   if (cmdName() == "ldata" || cmdName() == "lcounts")
   {
      // Y-scale will be log regardless of setplot setting.
      rangeVals.yScaleType = PlotStyle::LOG;
   }
   else
      rangeVals.yScaleType = settings.yLog() ? PlotStyle::LOG : 
                PlotStyle::LINEAR;
   if (settings.xOption() == CHANNELS)
      rangeVals.xScaleType = PlotStyle::LINEAR;
   else 
      rangeVals.xScaleType = settings.xLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
   
   if (rangeVals.yScaleType == PlotStyle::LOG)
   {
      // Let plotting package determine y ranges
      rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX;
   }
   else
   {
      // Plotting package determines upper y
      rangeVals.ranges.y1 = 0.0;
      rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX
                        + PlotStyle::YMIN;
   }
  //## end PlotData::setRanges%4ACCF6E90219.body
}

void PlotData::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotData::makeLabels%4B01C06A0366.body preserve=yes
   labels.title = activeModelStatus() ? settings.lookupLabelName("t:data:foldmodel") :
                        settings.lookupLabelName("t:data");
   
   // Can't simply use cmdName() for this since "lcounts" and "ldata" won't work.                    
   string cmdStr = m_isCounts ? string("counts") : string("data");
   string xKey(settings.makeXOptionDependentLabel(labels.x));
   // Now y label:
   string yLabel;
   string fullKey(string("y:") + cmdStr + xKey.substr(1));
   yLabel = settings.lookupLabelName(fullKey);
   settings.insertUnitLabel(yLabel, true);   
   labels.y = yLabel;
   
   if (settings.divideByArea())
   {
      string inverseArea = settings.lookupLabelName("y:suffix:area");
      yLabel += " ";
      yLabel += inverseArea;
      labels.y = yLabel;       
   }
  //## end PlotData::makeLabels%4B01C06A0366.body
}

// Additional Declarations
  //## begin PlotData%3DA1B20603E3.declarations preserve=yes
  //## end PlotData%3DA1B20603E3.declarations

//## begin module%3DA1B0B202CC.epilog preserve=yes
//## end module%3DA1B0B202CC.epilog
